from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.migration_abc import MigrationABC
from bot_data.db_context import DBContext


class LevelMigration(MigrationABC):
    name = '0.3_LevelMigration'

    def __init__(self, logger: DatabaseLogger, db: DBContext):
        MigrationABC.__init__(self)
        self._logger = logger
        self._db = db
        self._cursor = db.cursor

    def upgrade(self):
        self._logger.debug(__name__, 'Running upgrade')

        self._cursor.execute(
            str(f"""
            CREATE TABLE IF NOT EXISTS `Levels` (
                `Id` BIGINT NOT NULL AUTO_INCREMENT,
                `Name` VARCHAR(255) NOT NULL,
                `Color` VARCHAR(8) NOT NULL,
                `MinXp` BIGINT NOT NULL,
                `PermissionInt` BIGINT NOT NULL,
                `ServerId` BIGINT,
                `CreatedAt` DATETIME(6),
                `LastModifiedAt` DATETIME(6),
                PRIMARY KEY(`Id`),
                FOREIGN KEY (`ServerId`) REFERENCES `Servers`(`ServerId`)
            );
            """)
        )

    def downgrade(self):
        self._cursor.execute('DROP TABLE `Levels`;')

